
uniform int vertextype;
uniform int fb_texture;
uniform int blend_mode;

uniform mat4 d3dprojection_matrix;
uniform mat4 d3dviewport_matrix;

varying vec4 pos;

void main()
{
	pos = gl_Vertex;
	
	// TLVERTEX
	if(vertextype == 3)
	{
		pos.w = 1.0 / pos.w;
		pos.xyz *= pos.w;
		pos = gl_ProjectionMatrix * pos;
	}
	// LVERTEX and VERTEX
	else pos = d3dviewport_matrix * d3dprojection_matrix * gl_ModelViewMatrix * pos;
	
	gl_FrontColor.rgba = gl_Color.bgra;
	
	if(vertextype != 3 && gl_FrontColor.a > 0.5) gl_FrontColor.a = 0.5;
	
	if(blend_mode == -1) gl_FrontColor.a = 1.0;
	
	gl_TexCoord[0] = gl_MultiTexCoord0;
	
	if(fb_texture == 1) gl_TexCoord[0].t = 1.0 - gl_TexCoord[0].t;
	
	gl_Position = pos;
}
